<?php

use WSCOMUN\WSComunFClient;

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
require_once '../../../include/WSComunFClient.php';
$keyGDE2 = WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://innovacion-pre.gva.es/pai_bus_inno/GDE/GDEService_v2_00?wsdl'	// Instrumentales
);

/* Datos del certificado utilizado para las pruebas */
$v_opciones = array
(
		//'certFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.crt'),
		//'keyFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.key'),
		'passPhrase' 			=> null,
		'enableWSSecurity' 		=> false, //Innovacion
		'enableTrazabilidadPAI' => true,
		'idApp' 				=> 'WSCOMUN',
);


//print("\n<br>WSDL al que se accede: <a href='".$v_wsdl[WSComunFClient::KEYCLIENTE_GDE2]."'>Safe PRE GDE2</a><br/><br/>\n");

//Parametros de invocacin generales
$codApp = 'RABA';



// Genera identificador ENI
try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient($keyGDE2, $v_wsdl, $v_opciones);
	$clienteSIRCA->setDebugMode(true);

	$respuestaGDE2 = $clienteSIRCA->generarIdentificadorENIGDE2($codApp);
	$idENI = $respuestaGDE2['identificadorENI'];
	echo "Identificador ENI: $idENI";


	//Parametros de invocacin insertarDocumentoGDE
//	$contenidoPDF = file_get_contents('PDFSinFirmar.pdf');
/*
	$contenidoPDF =
<<<EOF
<?xml version="1.0" encoding="UTF-8"?>
<tns:FORMULARIO xmlns:tns="urn:es:gva:dgm:tra:xml:formulario:v1:model" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:es:gva:dgm:tra:xml:formulario:v1:model formulario.xsd ">
  <CAMPO id="APELLIDO1" tipo="simple">
      <VALOR>Garca</VALOR>
</CAMPO>
<CAMPO id="PROVINCIA" tipo="compuesto">
      <VALOR codigo="46">Valencia</VALOR>
</CAMPO>
<CAMPO id="INSTANCIAS" tipo="multivaluado">
      <VALOR codigo="001">Instancia1</VALOR>
      <VALOR codigo="002">Instancia2</VALOR>
</CAMPO>
</tns:FORMULARIO>
EOF;
*/
	$contenidoPDFB64 = base64_encode ('Hola Mundo');
	$metaENI = array(
			'versionNTI' => 'http://administracionelectronica.gob.es/ENI/XSD/v1.0/documento-e',
			'identificador' => $idENI,
			'tipoDocumental' => 'TD06',
			'nombreFormato' => 'xml',
			'organo' => array( 'A10000PRE' ),	// <!--1 or more repetitions: -->
			'fechaCaptura' => new DateTime('2014-07-31T09:25:17.030+02:00'),
			'estadoElaboracion' => 'EE99',
			'origenCiudadanoAdministracion' => false
	);
	$firmas = array(
			array(
					'tipo' => 'TF01',
					'CSV' => 'ASDRAWERW-WERQREQERQQER',
					'regCSV' => 'BOE-A-2013/3 '
			)
	);

	print("\n\n<br><br><br>Prueba de GDE: empaquetarDocumentoENI($codApp, CONTENIDOPDF, ...)<br>\n");
	$respuestaGDE2 = $clienteSIRCA->empaquetarDocumentoENIGDE2($codApp, $contenidoPDFB64, $metaENI, $firmas);

	$contenido = base64_decode( $respuestaGDE2['documentoENI'] );
	ob_end_clean();
	ob_start();
	//header("Content-Type: application/xml");
	header("Content-Disposition: attachment; filename='empENI_$idENI.tmp'");
	header('Expires: 0');
	header('Pragma: cache');
	header('Cache-Control: private');
	echo $contenido;
	ob_end_flush();

}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print($e->getTraceAsString());print("\n<br/>");
	print('<pre>');
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print($e->getMessage());
	print('</pre>');
};
//print("\n\n<br><br><br/>Referencia: $refDoc<br><br>\n\n");



?>