<?php

use WSCOMUN\WSComunFClient;

error_reporting(E_ERROR | E_WARNING | E_PARSE);

ini_set("soap.wsdl_cache_enabled", 0);

// Determina si se obtiene el cliente WS mediante el uso del factory (Nuevo metodo)
require_once '../../include/WSComunFClient.php';
$keyPF 		= WSComunFClient::KEYCLIENTE_PF;
$keyPFMOD	= WSComunFClient::KEYCLIENTE_PF_MOD;
$keyPFADM	= WSComunFClient::KEYCLIENTE_PF_ADM;

require_once 'libOpts.php';


/*
 * El script comprueba la funcion de envio de peticiones
 *
 * Uso: test_pf_sendRequest.php?requestId=xxxxxxx"
 *
 * Incluye llamadas a las siguiente funciones:
 * 	- sendRequest
 * 	- queryRequest
 */


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
	$keyPF			=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/QueryService_v2_00?wsdl',
	$keyPFMOD		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/ModifyService_v2_00?wsdl',
	$keyPFADM		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/AdminService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


$username = 'WSCOMUN';
$password = 'WSC4M5N';



// Informacion de uso
if (!isset($_REQUEST['requestId'])) {
	print("Debe indicar el id del request a buscar<br>\n");
	print("Uso: script.php?requestId=xxxxxxx");
	die;
}

$requestId = $_REQUEST['requestId'];

print("requestId introducido: $requestId<br>\n");



try
{
	set_time_limit(200);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_PF, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);


	// pf_mod_sendRequest
	$respuesta = $clienteSIRCA->pf_mod_sendRequest($username, $password, $requestId);
	print("<br>\nrequestId enviado: {$respuesta['requestId']}<br>\n");
	//print_r($respuesta);




	// pf_queryRequest
	$respuesta = $clienteSIRCA->pf_queryRequest($username, $password, $requestId);
	print("<br>\nInformacion basica de la solicitud:<br>\n");
	print("- Subject: {$respuesta['request']['subject']}<br>\n");
	print("- Reference: {$respuesta['request']['reference']}<br>\n");
	print("- Text: {$respuesta['request']['text']}<br>\n");
	print("- 1er Documento: {$respuesta['request']['documentList']['document']['identifier']}<br>\n");
	//print_r($respuesta);
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

// Muestra los enlaces a otras funcionalidades
showLinks($requestId);

?>