<?php

use WSCOMUN\WSComunFClient;
use WSCOMUN\PORTAFIRMAS\document;
use WSCOMUN\PORTAFIRMAS\documentType;

error_reporting(E_ERROR | E_WARNING | E_PARSE);

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyPF 		= WSComunFClient::KEYCLIENTE_PF;
$keyPFMOD	= WSComunFClient::KEYCLIENTE_PF_MOD;
$keyPFADM	= WSComunFClient::KEYCLIENTE_PF_ADM;

require_once 'libOpts.php';


/*
 * El script comprueba las funciones de manipulacin de documentos
 *
 * Uso: test_pf_testDocumentOps.php?requestId=xxxxxxx"
 *
 * Incluye llamadas a las siguiente funciones:
 * 	- insertDocument
 * 	- downloadDocument
 * 	- deleteDocument
 */


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
	$keyPF			=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/QueryService_v2_00?wsdl',
	$keyPFMOD		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/ModifyService_v2_00?wsdl',
	$keyPFADM		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/AdminService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


$username = 'WSCOMUN';
$password = 'WSC4M5N';



// Informacion de uso
if (!isset($_REQUEST['requestId'])) {
	print("Debe indicar el id del request a buscar<br>\n");
	print("Uso: script.php?requestId=xxxxxxx");
	die;
}

$requestId = $_REQUEST['requestId'];

print("requestId a consultar: $requestId<br>\n");



try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_PF, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);



	// pf_mod_insertDocument
	$docType = new documentType();
	$docType->setIdentifier('INFORME');
	$docType->setDescription('Informe generico');
	$docType->setValid(true);

	$doc = new document();
	$doc->setName('documento de prueba.pdf');
	$doc->setMime('application/pdf');
	$doc->setContent('[[-CONTENIDO EN BASE64-]]');
	$doc->setSign(true);
	$doc->setDocumentType($docType);

	$respuesta = $clienteSIRCA->pf_mod_insertDocument($username, $password, $requestId, $doc);
	$documentId = $respuesta['documentId'];
	print("documentId asociado a [requestId: $requestId]: $documentId<br>\n");
	//print_r($respuesta);



	// pf_downloadDocument
	$respuesta = $clienteSIRCA->pf_downloadDocument($username, $password, $documentId);
	$contenido64 = $respuesta['documentBinary'];
	$contenidoB = base64_decode($contenido64);
	print("<br>\nContenido del documento [$documentId]:<br>\n");
	print("- Base64: $contenido64<br>\n");
	print("- Binary: $contenidoB<br>\n");
	//print_r($respuesta);



	// pf_mod_deleteDocument
	$respuesta = $clienteSIRCA->pf_mod_deleteDocument($username, $password, $documentId);
	$docDeleteId = $respuesta['documentId'];
	print("<br>\nDocumento eliminado: $docDeleteId<br>\n");
	//print_r($respuesta);


}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

// Muestra los enlaces a otras funcionalidades
showLinks($requestId);

?>