<?php

use WSCOMUN\WSComunFClient;

require_once '../../include/WSComunFClient.php';
$keyAutentica 	= WSComunFClient::KEYCLIENTE_AUTENTICA;
$keyFirma 		= WSComunFClient::KEYCLIENTE_FIRMA;
$keyAutoriza 	= WSComunFClient::KEYCLIENTE_AUTORIZA;



/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyAutentica 		=> 'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/SAFE/AutenticacionArangi_v1_00?wsdl',
		//$keyAutentica 	=> 'https://instrumental-pre.gva.es/pai_bus_ins/SAFE/Autenticacion_v1_00?wsdl', //Instrumentales
		$keyFirma 			=> 'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/SAFE/FirmaArangi_v1_00?wsdl',
		$keyAutoriza 		=> 'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/SAFE/AutorizacionHDFI_v1_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
/*
$v_datosCertif = array
(
		'certFile' => realpath('../cert/DIETASGVA-PRE.crt'),
		'keyFile' => realpath('../cert/DIETASGVA-PRE.key'),
		'passPhrase'=> null
);

$vTrazabilidad = array
(
		'nsCert'=>'02d8f243f4272489',
		'idApp'=>'DIETASGVA'
);
*/
/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
		'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
		'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
		'passPhrase'=> null
);

$vTrazabilidad = array
(
		'nsCert'=>	'2039d6a41976eedf',	//02d8f243f4272489
		'idApp'=>	'RABAC'				//RABAC
);


print("\n\n<br/><br><br/>Prueba de firma: firmarCertificado()<br/>\n");
print("WSDL al que se accede: <a href='".$v_wsdl[$keyFirma]."'>Safe PRE Firma</a><br/><br/>\n");


//Parametros de invocacin de testeo proporcionados por SAFE
$idSession = 'TRA';
$idCertificado = '5';
$contenidoPDF = file_get_contents('../PDFSinFirmar.pdf');
$contenidoPDFB64 = base64_encode ($contenidoPDF);

try
{

	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_FIRMA, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);

	$docFirmado = $clienteSIRCA->firmarCertificadoServer($idSession, $idCertificado, $contenidoPDFB64);

	ob_end_clean();
	ob_start();
	print $docFirmado;
	header("Content-Type: application/pdf");
	header("Content-Disposition: attachment; filename=pdfFirmado.pdf");
	header('Expires: 0');
	header('Pragma: cache');
	header('Cache-Control: private');
	ob_end_flush ();
}
catch (Exception $e)
{
	print('<pre>');
	print_r($e);print("\n\n<br><br>\n\n");
	print_r($clienteSIRCA->__getLastRequestHeaders());
	print_r($clienteSIRCA->__getLastRequest());
	print_r($clienteSIRCA->__getLastResponse());
	print_r($clienteSIRCA->__getLastResponseHeaders());
	print('</pre>');
}



?>